//************************************************************************
//TAG3P VERSION 3.1 copyrights by Nguyen Xuan Hoai                       *
//This module contains fitness case and functions to compute raw fitness *
//and standardized fitness for Boolean Decision tree for 6-Multiplexer   *
//************************************************************************
#ifndef __BOOL6PLEXER__
#define __BOOL6PLEXER__

#include<iostream.h>
#include<string.h>
#include<stdio.h>
#include<assert.h>
#include<math.h>
#include<stdlib.h>
#include "gconst.h"
#include "random.h"
#include "term.h"
#include "stree.h"
#include  "genetic.h"
#define NUMADDRESS  2
#define NUMVAR  6
#define NUMFITCASE 64
struct _sample{
		 BOOL x[NUMVAR];
		 BOOL y;
		};
typedef struct _sample sample;
sample fitcase[NUMFITCASE];
BOOL SuccPredicate=FALSE;
void SetFitCase()
{
 int i,h,l,t;

 for(i=0;i<NUMFITCASE;i++)
  {
   //change to boonlean
   h=i;
   for(l=0;l<NUMVAR;l++)
    {
     if((h % 2)==1)
       fitcase[i].x[l]=TRUE;
     else
      fitcase[i].x[l]=FALSE;
     h=h/2;
    }
  //compute the address value
   h=0;
   t=1;
   for(l=0;l<NUMADDRESS;l++)
    {
     if(fitcase[i].x[l])
       h=h+t;
     t=t*2;
    }
    fitcase[i].y=fitcase[i].x[h+NUMADDRESS];
  }
}
//********************************************************************
//This function compute the function (in tree form) with given input *
//********************************************************************
BOOL Compute(node *st,BOOL x[NUMVAR])
{
 node *p;
 BOOL l,r;
 int i;
 if (!strcmp(st->name,"f"))
     return FALSE;
  else
    if (!strcmp(st->name,"t"))
      return TRUE;
   else//functions
   {
     p=st->children;
     i=0;
     while(strcmp(st->name,glfunction[i].name))
     i++;
     if(x[i])
      return Compute(p,x);
     else
      return Compute(p->sibling,x);
    }
}
//*********************************************
//Compute the raw fitness for an invidual     *
//*********************************************
double ComputeRF(individual  st)
{
  double sum=0;
  BOOL t;
  int i;
  int hit;
  hit=0;
  for(i=0;i<NUMFITCASE;i++)
   {
     t=Compute(st.chrom,fitcase[i].x);
     if(t==fitcase[i].y)
     {
      hit++;
      sum++;
     }
   }
   if(hit==NUMFITCASE)
     SuccPredicate=TRUE;
   return sum;
}
void LoadTerm()
{
 cout<<"Loading terms...";
 InitTerm();
 AddTerm("a0",2);
 AddTerm("a1",2);
 AddTerm("d0",2);
 AddTerm("d1",2);
 AddTerm("d2",2);
 AddTerm("d3",2);
 AddTerm("f",0);
 AddTerm("t",0);
 SwapTerm(100);
 cout<<endl<<"Done!"<<endl;

}
#endif
