//************************************************************************
//This module contains fitness case and functions to compute raw fitness *
//as well as standardized fitness for Symbolic Regression Problem        *
//Programmed by NXH.                                                     *
//************************************************************************
#ifndef __TRIGONO__
#define __TRIGONO__

#include<iostream.h>
#include<string.h>
#include<stdio.h>
#include<assert.h>
#include<math.h>
#include<stdlib.h>
#include "random.h"
#include "term.h"
#include "stree.h"
#define NUMVAR  5
#define NUMFITCASE 32
//****************************************
//Fitness cases for symbolic regression  *
//They are sampled between -1 and 1      *
//Seed for sampling 12345                *
//****************************************
struct _sample{
		 BOOL x[NUMVAR];
		 BOOL y;
		};
typedef struct _sample sample;
sample fitcase[NUMFITCASE];
BOOL SuccPredicate=FALSE;
void SetFitCase()
{
 int i,l,h;
 for(i=0;i<NUMFITCASE;i++)
  {
    h=i;
   for(l=0;l<NUMVAR;l++)
    {
     if((h % 2)==1)
       fitcase[i].x[l]=TRUE;
     else
      fitcase[i].x[l]=FALSE;
     h=h/2;
    }
   h=0;
   for(l=0;l<NUMVAR;l++)
    if(fitcase[i].x[l])
      h++;
   if((h % 2)==0)
    fitcase[i].y=TRUE;
   else
    fitcase[i].y=FALSE;
  }
}
//Some Boolean function
BOOL AND(BOOL a, BOOL b)
{
 if (a&&b)
  return TRUE;
 else
  return FALSE;
}
BOOL OR(BOOL a,BOOL b)
{
 if(a||b)
  return TRUE;
 else
  return FALSE;
}
BOOL NAND(BOOL a,BOOL b)
{
 if(!(a&&b))
  return TRUE;
 else
  return FALSE;
}
BOOL NOR(BOOL a,BOOL b)
{
 if(!(a||b))
  return TRUE;
 else
  return FALSE;
}
BOOL XOR(BOOL a,BOOL b)
{
 if(a==b)
  return FALSE;
else
 return TRUE;
}
BOOL EQ(BOOL a,BOOL b)
{
 if(a==b)
 return TRUE;
else
 return FALSE;
}

//********************************************************************
//This function compute the function (in tree form) with given input *
//********************************************************************
BOOL Compute(node *st,BOOL x[NUMVAR])
{
 node *p,*q;
 BOOL l,r;
 if (!strcmp(st->name,"X1"))
     return x[0];
  else
    if (!strcmp(st->name,"X2"))
      return x[1];
   else
    if (!strcmp(st->name,"X3"))
     return x[2];
   else
   if (!strcmp(st->name,"X4"))
     return x[3];
    else
      if(!strcmp(st->name,"X5"))
       return x[4];
 else 
  {
   p=st->children;
   q=p->sibling;
   l=Compute(p,x);
   r=Compute(q,x); 
   if(!strcmp(st->name,"AND"))
     return AND(l,r);
    else
     if(!strcmp(st->name,"OR"))
       return OR(l,r);
      else
       if (!strcmp(st->name,"NAND"))
	return NAND(l,r);
         else
      // if(!strcmp(st->name,"NOR"))
	return NOR(l,r);
       //  else
      // if(!strcmp(st->name,"XOR"))
       //  return XOR(l,r);
       // else
        // return EQ(l,r);
    }
}
//*********************************************
//Compute the raw fitness for an invidual     *
//*********************************************
double ComputeRF(individual st)
{
  double sum=0;
  BOOL t;
  int i;
  int hit;
  hit=0;
  for(i=0;i<NUMFITCASE;i++)
   {
     t=Compute(st.chrom,fitcase[i].x);
     if(t==fitcase[i].y)
     {
      hit++;
      sum++;
     }
   }
   if(hit==NUMFITCASE)
     SuccPredicate=TRUE;
   return sum;
}
//****************************************************************
//This function initializes elementary trees and adjoining table *
//****************************************************************

void LoadTerm()
{
 cout<<endl<<"Loading Term...";
 InitTerm();
 AddTerm("AND",2);
 AddTerm("OR",2);
 AddTerm("NAND",2);
 AddTerm("NOR",2);
 //AddTerm("XOR",2);
 //AddTerm("EQ",2);
 AddTerm("X1",0);
 AddTerm("X2",0);
 AddTerm("X3",0);
 AddTerm("X4",0);
 AddTerm("X5",0);
 SwapTerm(100);
 cout<<"Done!";
}
#endif
